Lua_DailyGiftItem = class("Lua_DailyGiftItem", Lua_ListCell);
function Lua_DailyGiftItem:ctor(p)
    self:superCall("ctor", p, "DailyGiftItem_skin");
end

function Lua_DailyGiftItem:buildShowItem()
	self:superCall("buildShowItem");

	self.rewardList = Lua_DragList.new(self.content, 635, 112, Lua_AxisDefine.Horizontal);
	self.rewardList:setListCell(Lua_ItemIconCell, 112, 112, 1);
	self.rewardList:setLocation(-200, -15, 0);
	self.rewardList:setCellSpacing(5, 0);
	self.rewardList:setScale(0.8, 0.8, 0.8);

	self.stateBtn:addClickFuntion(self, self.buyGift);
end

function Lua_DailyGiftItem:setData(data)
	if data == nil then
		return;
	end
	self.data = data;

	self.tipsTxt.text = data.title;
	self.conditionsTipsTxt.text = LanUtil.formateStr(202701, tostring(data.limitTimes));

	if data.limitTimes > 0 then
		if data.recharge == 0 then
			self.stateBtn:setLangValue(202704);
		else
			self.stateBtn.label = LanUtil.formateStr(202705, tostring(data.recharge));
		end
	end
	self.stateBtn:setEnable(data.limitTimes > 0);
	self.sellOutSp:setEnable(data.limitTimes <= 0);

	local len = #data.reward;
	self.rewardList:setContentRect(120 * len, 112);
	self.rewardList:setArrayData(data.reward);
	self.rewardList.canDrag = #data.reward > 4;

	self:showRedDot(data.recharge == 0 and data.limitTimes > 0);
end

function Lua_DailyGiftItem:buyGift()
	self.data:buyGift();
end

function Lua_DailyGiftItem:showRedDot(bShow)
	if bShow == true then
		if self.redPoint == nil then
			self.redPoint = Lua_RedPointIcon.new(self.content);
			self.redPoint:setLocation(285, 15, 0);
			self.redPoint:createRedPointEff();
		end
		self.redPoint:updateRedPointShow(true);
	else
		if self.redPoint ~= nil then
			self.redPoint:updateRedPointShow(false);
		end
	end
end

function Lua_DailyGiftItem:dispose()
	if self.rewardList ~= nil then
		self.rewardList:dispose();
		self.rewardList = nil;
	end
	self.data = nil;

	self:superCall("dispose");
end