-- 每日礼包
checkRequire("Lua_DailyGiftItem");
Lua_DailyGiftPanel = class("Lua_DailyGiftPanel", Lua_DisplayObject);
function Lua_DailyGiftPanel:ctor(p)
	self:superCall("ctor", p, "DailyGiftPanel_skin");
end

function Lua_DailyGiftPanel:buildShowItem()
	self:superCall("buildShowItem");

	self.selectIndex = 1;

	self.rewardBg:SetDimensions(MainWinDefine.DEFAULT_WIDTH, 1160 + self.adaptHeight);
	self.bannerTxt:setLangValue(202700);

	-- 礼包类型
	self.giftTypeList = Lua_DragList.new(self.content, 440, 40, Lua_AxisDefine.Horizontal);
	self.giftTypeList:setListCell(Lua_DailyGiftTypeItem, 100, 40, 1);
	self.giftTypeList:setRectAnchor(1);
	self.giftTypeList:setLocation(-80, -340, 0);
	self.giftTypeList.content.name = "giftTypeList";
	
	-- 礼包item
	self.giftList = Lua_DragList.new(self.content, 635, 665 + self.adaptHeight, Lua_AxisDefine.Vertical);
	self.giftList:setListCell(Lua_DailyGiftItem, 635, 145, 1);
	self.giftList:setLocation(0, 10, 0);
	self.giftList.content.name = "giftList";

	self.buyBtn:addClickFuntion(self, self.buyAllGift);

	self:addLuaEvent("GIFT_TYPE_SELECT", self, self.onGiftTypeSelect);
	self:addLuaEvent("UPDATE_DAILYGIFT_INFO", self, self.updateGiftTypeItem);
	Lua_ProxyManager.getProxy("Lua_RaccoonMartProxy"):sDailyGiftInInfo();
end

function Lua_DailyGiftPanel:setData(data)
end

function Lua_DailyGiftPanel:onScreenResize(adaptHeight)
	self:superCall("onScreenResize", adaptHeight);

	self.rewardBg:SetDimensions(MainWinDefine.DEFAULT_WIDTH, 1160 + adaptHeight);
	self.giftList:setContentRect(635, 665 + adaptHeight);
end

function Lua_DailyGiftPanel:updateGiftTypeItem()
	local arr = DataCenter.dailyGiftData:getTypeArr();
	if arr:getSize() <= 0 then
		return;
	end

	self.giftTypeList:setArrayData(arr);
	self.giftTypeList.canDrag = arr:getSize() > 4;
	self.giftTypeList.showList[self.selectIndex]:onPressClick();
	self.giftTypeList:moveToIndex(self.selectIndex, true, false);
end

function Lua_DailyGiftPanel:onGiftTypeSelect(data)
	self:updatedailyPanel(data.giftType);
	self.selectIndex = self:getSelectNum(data.giftType);
	self.originalCost.text = LanUtil.formateStr(202702, tostring(data.price));
	self.curCost.text = LanUtil.formateStr(202703, tostring(data.discountPrice));
end

function Lua_DailyGiftPanel:updatedailyPanel(giftType)
	local arr = DataCenter.dailyGiftData:getGiftArrByDic(giftType);
	if arr:getSize() <= 0 then
		return;
	end

	self.giftList:setArrayData(arr);
	self.canBuy = DataCenter.dailyGiftData:getTypeVoByType(giftType).canBuy;
	self.buyBtn:setStyle(not self.canBuy and 3 or 1);
end

function Lua_DailyGiftPanel:buyAllGift()
	if self.canBuy then
		self.giftTypeList.showList[self.selectIndex].data:buyAllGift();
	else
		OperateAlert.showLangValue(202706);
	end
end

function Lua_DailyGiftPanel:getSelectNum(giftType)
	local value;
	local typeIdx = 1;
	for i = 1, self.giftTypeList.showList:getSize() do
		value = self.giftTypeList.showList[i].data.giftType;
		self.giftTypeList.showList[i]:updateSelect(value == giftType)
		if value == giftType then
			typeIdx = i;
		end
	end
	return typeIdx;
end

function Lua_DailyGiftPanel:dispose()
	if self.giftTypeList ~= nil then
		self.giftTypeList:dispose();
		self.giftTypeList = nil;
	end
	if self.giftList ~= nil then
		self.giftList:dispose();
		self.giftList = nil;
	end

	self:superCall("dispose");
end





--------------------------------------------------





-- 礼包类型
Lua_DailyGiftTypeItem = class("Lua_DailyGiftTypeItem", Lua_ListCell);
function Lua_DailyGiftTypeItem:ctor(p)
    self:superCall("ctor", p);
end

function Lua_DailyGiftTypeItem:buildShowItem()
	self:superCall("buildShowItem");

	self.btnIcon = UICreate.createUIAtlasImage(self.content, "common_altas_1","ui_common_button_041_n", 0, 0, 100, 40); 
	self.giftNameTxt = UICreate.createLabel(self.content, "", 0, 0, 100, 40, 24);
	self.giftNameTxt.fontName = Lua_MyUISettings.huakangFontName;
	self.giftNameTxt.alignmentValue = 4;
end

function Lua_DailyGiftTypeItem:setData(data)
	self.data = data;
	if data == nil then
		return;
	end

	self.giftNameTxt.text = data.name;

	self:showRedDot(DataCenter.dailyGiftData.redShowState[data.giftType]);
end

function Lua_DailyGiftTypeItem:onPressClick()
	if self.data == nil then
		return;
	end
	Lua_MsgUtil.callFunc("GIFT_TYPE_SELECT", self.data);
end

function Lua_DailyGiftTypeItem:updateSelect(val)
	if self.data == nil then
		return;
	end

	if val == true then
        self.btnIcon:setAltas("common_altas_1", "ui_common_button_041_p");
        self.giftNameTxt.colorStr = Lua_ColorDefine.transColorStr("A84A27");
    else
        self.btnIcon:setAltas("common_altas_1", "ui_common_button_041_n");
        self.giftNameTxt.colorStr = Lua_ColorDefine.transColorStr("F1EAE7");
    end
end

function Lua_DailyGiftTypeItem:showRedDot(bShow)
	if bShow == true then
		if self.redPoint == nil then
			self.redPoint = Lua_RedPointIcon.new(self.content);
			self.redPoint:setLocation(37, 7, 0);
			self.redPoint:createRedPointEff();
		end
		self.redPoint:updateRedPointShow(true);
	else
		if self.redPoint ~= nil then
			self.redPoint:updateRedPointShow(false);
		end
	end
end

function Lua_DailyGiftTypeItem:dispose()
	if self.btnIcon ~= nil then
		self.btnIcon:dispose();
		self.btnIcon = nil;
	end
	if self.giftNameTxt ~= nil then
		self.giftNameTxt:dispose();
		self.giftNameTxt = nil;
	end
	self.data = nil;
	
	self:superCall("dispose");
end