-- 月卡
Lua_MonthCardPanel = class("Lua_MonthCardPanel", Lua_DisplayObject);
function Lua_MonthCardPanel:ctor(p)
	self:superCall("ctor", p);
end

function Lua_MonthCardPanel:buildShowItem()
	self:superCall("buildShowItem");

	self.banner = UICreate.createLabel(self.content, LanUtil.getValue(202400), -200, -200, 250, 120, 40);
	self.banner.anchor = Lua_WindowUtil.getAnchor(1);
	self.banner.alignmentValue = 3;

	self.cardList = Lua_DragList.new(self.content, 680, 600, Lua_AxisDefine.Horizontal);
	self.cardList:setListCell(Lua_MonthCardItem, 340, 600, 1);
	self.cardList.canDrag = false;

	self:addLuaEvent("UPDATE_MONTHCARD_INFO", self, self.updateMonthCardInfo);
	Lua_ProxyManager.getProxy("Lua_RaccoonMartProxy"):sMonthCardInInfo();
end

function Lua_MonthCardPanel:setData(data)
end

function Lua_MonthCardPanel:onScreenResize(adaptHeight)
	self:superCall("onScreenResize", adaptHeight);
end

function Lua_MonthCardPanel:updateMonthCardInfo()
	self.cardList:setArrayData(DataCenter.monthCardData.monthCardDic);
end

function Lua_MonthCardPanel:dispose()
	if self.banner ~= nil then
		self.banner:dispose();
		self.banner = nil;
	end
	if self.cardList ~= nil then
		self.cardList:dispose();
		self.cardList = nil;
	end

	self:superCall("dispose");
end





--------------------------------------------------





Lua_MonthCardItem = class("Lua_MonthCardItem", Lua_ListCell);
function Lua_MonthCardItem:ctor(p)
    self:superCall("ctor", p, "MonthCardItem_skin");
end

function Lua_MonthCardItem:buildShowItem()
	self:superCall("buildShowItem");

	self.receiveBtn:addClickFuntion(self, self.onActiveClick);
end

function Lua_MonthCardItem:setData(data)
	self.data = data;
	if data == nil then
		return;
	end

	self.name.text = data.describe;
	self.icon:setAltas(data.iconAtlas, data.iconSprite);
	self.dailyNum.text = data.reward[2];
	self.totalNum.text = data.total_Reward;
	self.tips.text = LanUtil.formateStr(202401, data.residue_Days);

	if data.draw_State == 1 then
		self.receiveBtn:setLangValue(202402) -- 可领取
	elseif data.draw_State == 2 then
		self.receiveBtn:setLangValue(202403) -- 已领取
	else
		self.receiveBtn:setLangValue(202404) -- 不可领取

		self.progressBar:setMaxValue(data.total_Recharge);
		self.progressBar:setValue(data.aggregatment);
		self.progressBar:setText(LanUtil.formateStr(202405, tostring(data.aggregatment), tostring(data.total_Recharge)));

		self.tips.text = LanUtil.formateStr(202406, tostring(data.total_Recharge));
	end
	
	self.progressBar:setEnable(data.draw_State == 0);
	self.receiveBtn:setStyle(data.draw_State == 2 and 3 or 1);
	self:showRedDot(data.draw_State == 1);
end

function Lua_MonthCardItem:showRedDot(bShow)
	if bShow == true then
		if self.redPoint == nil then
			self.redPoint = Lua_RedPointIcon.new(self.content);
			self.redPoint:setLocation(79, -227, 0);
			self.redPoint:createRedPointEff();
		end
		self.redPoint:updateRedPointShow(true);
	else
		if self.redPoint ~= nil then
			self.redPoint:updateRedPointShow(false);
		end
	end
end

function Lua_MonthCardItem:onActiveClick()
	if self.data.draw_State == 0 then
		DataCenter.funcPathUtil:gotoFunction(1024);
	elseif self.data.draw_State == 2 then
		OperateAlert.showLangValue(202403)
	else
		Lua_ProxyManager.getProxy("Lua_RaccoonMartProxy"):sGetMonthCardReward(self.data.grade);
	end
end

function Lua_MonthCardItem:dispose()
	if self.redPoint ~= nil then
		self.redPoint:dispose();
		self.redPoint = nil;
	end
	self.data = nil;

	self:superCall("dispose");
end